' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/22 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class rmMain

    '
    Private Const PI As Double = 3.14159265358979

    '͈
    Private m_ExeRegion As New FvRectangle

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    'XY_
    Private m_pStandardPoint As New FvPoint
    Private m_dblStandardAngle As Double  'P=WA

    'GbWo(␳OW)
    Private m_pEdgeScanLine As New FvLineSegment

    Private Sub rmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'ݒpRg[̏
        cmbSearchMode.Items.Add("ʏ̃p^[")   ' NORMAL_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' BLACK_LINE_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' WHITE_LINE_PATTERN"
        cmbSearchMode.Items.Add("sp^[")   ' UNSTABLE_PATTERN"
        cmbSearchMode.SelectedIndex = 0

        cmbPrecision.Items.Add("ʏ퐸x") ' NORMAL_MODE"
        cmbPrecision.Items.Add("x")   ' HIGH_MODE"
        cmbPrecision.Items.Add("x") ' SUPER_MODE"
        cmbPrecision.SelectedIndex = 0

        cmbEdgeColor.Items.Add("") 'WHITE_TO_BLACK
        cmbEdgeColor.Items.Add("") 'BLACK_TO_WHITE
        cmbEdgeColor.Items.Add("ɐ") 'ALL_COLOR
        cmbEdgeColor.SelectedIndex = 2

        cmbEdgePoint.Items.Add("ő_")   'POINT_PEAK lő̈ʒuGbWƂ܂
        cmbEdgePoint.Items.Add("ŏ̓_") 'POINT_1ST lԍŏɉzʒuGbWƂ܂
        cmbEdgePoint.SelectedIndex = 0

        cmbEdgeStartPos.Items.Add("n_I_") 'FROM_START n_ʒuGbW܂
        cmbEdgeStartPos.Items.Add("I_n_") 'FROM_END I_ʒuGbW܂
        cmbEdgeStartPos.SelectedIndex = 0

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            frmDisplayEx.Show()

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        frmDisplayEx.AxFvxDisplayEx1.CreateDisplay()
        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        'GbWoC̏lݒ
        m_pEdgeScanLine.xs = 300
        m_pEdgeScanLine.ys = 250
        m_pEdgeScanLine.xe = 400
        m_pEdgeScanLine.ye = 250

    End Sub

    Private Sub rmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If
        End If

    End Sub

    Private Sub btnSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPattern2.Click, btnSetPattern1.Click

        Dim pRect As New FvRectangle    'p^[̈̐ݒ
        Dim pPoint As New FvPoint       'p^[_

        Dim intOK As Integer
        Dim dblTemp As Double

        'o^̏`ݒ
        AxFvxROI1.InitPoint()
        AxFvxROI1.InitRectangle()
        AxFvxROI1.InitLineSegment()
        AxFvxROI1.UsePoint = True
        AxFvxROI1.UseRectangle = True
        AxFvxROI1.UseLineSegment = False
        pRect.xs = 100
        pRect.ys = 100
        pRect.xe = 200
        pRect.ye = 200
        AxFvxROI1.SetRectangle(pRect)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(pRect)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If pRect.xe < pRect.xs Then
                dblTemp = pRect.xs
                pRect.xs = pRect.xe
                pRect.xe = dblTemp
            End If
            If pRect.ye < pRect.ys Then
                dblTemp = pRect.ys
                pRect.ys = pRect.ye
                pRect.ye = dblTemp
            End If

            If AxFvxROI1.CheckPoint = 1 Then
                AxFvxROI1.GetPoint(pPoint)
            Else
                MsgBox("p^[_w肳܂łB" & vbCr & "p^[`̒S_Ƃēo^܂", , "p^[o^")

                pPoint.x = (pRect.xs + pRect.xe) / 2
                pPoint.y = (pRect.ys + pRect.ye) / 2
            End If

            Select Case sender.name
                Case "btnSetPattern1"
                    AxFvxPattern1.MakePattern(AxFvxImage1.GetOcx(), pRect, pPoint)
                Case "btnSetPattern2"
                    AxFvxPattern2.MakePattern(AxFvxImage1.GetOcx(), pRect, pPoint)
            End Select
        End If

    End Sub

    'p^[̃}XNݒ
    Private Sub btnSetPatternMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPatternMask2.Click, btnSetPatternMask1.Click

        Select Case sender.name
            Case "btnSetPatternMask1"
                AxFvxPattern1.DefMask()
            Case "btnSetPatternMask2"
                AxFvxPattern2.DefMask()
        End Select

    End Sub

    'p^[̕\
    Private Sub btnDispPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPattern2.Click, btnDispPattern1.Click

        Select Case sender.name
            Case "btnDispPattern1"
                AxFvxPattern1.Disp()
            Case "btnDispPattern2"
                AxFvxPattern2.Disp()
        End Select

    End Sub

    'p^[t@C̓Ǎ
    Private Sub btnLoadPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadPattern2.Click, btnLoadPattern1.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        OpenFileDialog1.DefaultExt = "*.pat"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length <> 0 Then
            Try
                Select Case sender.name
                    Case "btnLoadPattern1"
                        AxFvxPattern1.LoadPattrenFileName = OpenFileDialog1.FileName
                        AxFvxPattern1.Load()
                    Case "btnLoadPattern2"
                        AxFvxPattern2.LoadPattrenFileName = OpenFileDialog1.FileName
                        AxFvxPattern2.Load()
                End Select

            Catch ex As Exception
                MsgBox("p^[Ǎݎs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'p^[t@C̕ۑ
    Private Sub btnSavePattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSavePattern2.Click, btnSavePattern1.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        SaveFileDialog1.DefaultExt = "*.pat"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length <> 0 Then
            Try
                Select Case sender.name
                    Case "btnSavePattern1"
                        AxFvxPattern1.SavePattrenFileName = SaveFileDialog1.FileName
                        AxFvxPattern1.Save()
                    Case "btnSavePattern2"
                        AxFvxPattern2.SavePattrenFileName = SaveFileDialog1.FileName
                        AxFvxPattern2.Save()
                End Select

            Catch ex As Exception
                MsgBox("p^[ۑs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    'oݒ
    Private Sub btnSetEdgeScanLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetEdgeScanLine.Click

        Dim intOK As Integer

        'ݒ_CAȌl߂Ă
        AxFvxROI2.InitPoint()
        AxFvxROI2.InitRectangle()
        AxFvxROI2.SetLineSegment(m_pEdgeScanLine)

        'FvxROIgČoI_CAOo
        AxFvxROI2.UseLineSegment = True
        AxFvxROI2.UsePoint = False
        AxFvxROI2.UseRectangle = False

        AxFvxROI2.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI2.CheckLineSegment = 1 Then
            AxFvxROI2.GetLineSegment(m_pEdgeScanLine)
        End If

    End Sub

    'T[`sǍʂƂĕۑ
    Private Sub btnSetStandard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetStandard.Click

        Dim pSearchResult0 As New FvSearchResult
        Dim pSearchResult1 As New FvSearchResult

        Dim pLine As New FvLine

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()

        'ep[^̓Kp
        If ApplyChanges = -1 Then Exit Sub

        '͈͂ŕ\
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

        If Search(pSearchResult0, pSearchResult1) = 0 Then
            'T[`ʂ͐Ԃŕ\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)

            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult0)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult1)

            '2̃T[`ʂ̒_ƁAxƂ̌p߂
            m_pStandardPoint.x = (pSearchResult0.x + pSearchResult1.x) / 2
            m_pStandardPoint.y = (pSearchResult0.y + pSearchResult1.y) / 2
            'px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
            '̂߁A̒l͉EŐɂȂ܂B
            m_dblStandardAngle = ArcTan((pSearchResult1.x - pSearchResult0.x), (pSearchResult1.y - pSearchResult0.y))

            'Q̃T[`ʂ̒_Ƀ}[N\
            DrawPointMark(m_pStandardPoint)

            'FvxCalcDataR|[lg𗘗pāA
            '_ʂ钼̎߂
            AxFvxCalcData1.CalcLine_TwoPoint(pSearchResult0, pSearchResult1)
            AxFvxCalcData1.CalcLine_GetResult(pLine)
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(192, 192, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pLine)

            'GbWoC\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_pEdgeScanLine)
        End If

    End Sub

    'Rg[ɓ͂ꂽݒlKp
    Private Function ApplyChanges() As Integer

        Dim intTemp As Integer

        'p[^G[ꍇ Ԓl = -1
        ApplyChanges = -1

        'p[^ݒ
        AxFvxCorrelation1.SetInspectArea(m_ExeRegion)                   '͈
        AxFvxCorrelation1.SearchMode = cmbSearchMode.SelectedIndex    'T[`[hiׂȂǂ̃p^[Ɏgpj
        AxFvxCorrelation1.Precision = cmbPrecision.SelectedIndex      'T[`

        '摜̏
        If Integer.TryParse(txtCondition.Text, intTemp) = False Or intTemp < 1 Or intTemp > 9 Then
            MsgBox("Ԃ 1`9 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.Condition = intTemp

        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("XRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.ScoreThresh = intTemp

        'r臒l
        If Integer.TryParse(txtMiddleThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("rXRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.ScoreThresh2 = intTemp

        'T[`
        AxFvxCorrelation1.SearchNum = 1

        '͈͐ڐGĂ̂o邩
        If chkWndTouch.Checked = True Then
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.OFF
        End If


        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 0 Or intTemp > 200 Then
            MsgBox("臒l 0`200 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxEdge1.Thresh = intTemp

        'Е
        If Integer.TryParse(txtLineWidth.Text, intTemp) = False Or intTemp < 0 Then
            MsgBox("Е0ȏŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxEdge1.LineWidth = intTemp

        AxFvxEdge1.EdgeColor = cmbEdgeColor.SelectedIndex         'GbWɐ
        AxFvxEdge1.StartPosition = cmbEdgeStartPos.SelectedIndex  'o
        AxFvxEdge1.EdgePoint = cmbEdgePoint.SelectedIndex         'GbWʒu

        'G[
        ApplyChanges = 0

    End Function

    '2̓o^p^[ɂāAT[`s
    'Ԓl  I=0 , ُI(p^[Ȃetc)=-1
    Private Function Search(ByVal pGSResult0 As FvSearchResult, ByVal pGSResult1 As FvSearchResult)

        Dim intCount As Integer
        Dim intErr As Integer

        'G[͕Ԓl = -1
        Search = -1

        'ep[^̓Kp
        If ApplyChanges() = -1 Then Exit Function

        Try
            'p^[1T[`s
            AxFvxCorrelation1.SetPattern(AxFvxPattern1.GetOcx())
            AxFvxCorrelation1.Execute(AxFvxImage1.GetOcx(), intCount)

            If intCount = 1 Then
                AxFvxCorrelation1.GetResult(0, pGSResult0)

                'p^[2T[`s
                AxFvxCorrelation1.SetPattern(AxFvxPattern2.GetOcx())
                AxFvxCorrelation1.Execute(AxFvxImage1.GetOcx(), intCount)

                If intCount = 1 Then
                    AxFvxCorrelation1.GetResult(0, pGSResult1)
                    'p^[2ƂԒl = 0
                    Search = 0
                Else
                    MsgBox("p^[2܂", vbExclamation, "G[")
                End If
            Else
                MsgBox("p^[1܂", vbExclamation, "G[")
            End If
        Catch ex As Exception
            AxFvxCorrelation1.GetErrReport(intErr)
            MsgBox(GetCorrelationErrMesg(intErr), vbExclamation, "G[")
        End Try

    End Function

    '-΁`΂܂ŌvZł悤Atng
    Private Function ArcTan(ByVal dbl_x As Double, ByVal dbl_y As Double) As Double

        If dbl_x > 0 Then
            ArcTan = Math.Atan(dbl_y / dbl_x)
        Else
            If dbl_y > 0 Then
                ArcTan = PI - Math.Atan(dbl_y / -dbl_x)
            Else
                ArcTan = Math.Atan(-dbl_y / -dbl_x) - PI
            End If
        End If

    End Function

    'lpɏ\̃}[N\
    Private Sub DrawPointMark(ByVal pPoint As FvPoint)

        Dim pBox As New FvRectangle
        Dim pLineSeg As New FvLineSegment

        pBox.xs = pPoint.x - 3
        pBox.ys = pPoint.y - 3
        pBox.xe = pPoint.x + 3
        pBox.ye = pPoint.y + 3
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pBox)

        pLineSeg.xs = pPoint.x - 8
        pLineSeg.xe = pPoint.x + 8
        pLineSeg.ys = pPoint.y
        pLineSeg.ye = pPoint.y
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pLineSeg)

        pLineSeg.xs = pPoint.x
        pLineSeg.xe = pPoint.x
        pLineSeg.ys = pPoint.y - 8
        pLineSeg.ye = pPoint.y + 8
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pLineSeg)

    End Sub

    'Yvs
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        'O[T[`̌
        Dim pSearchResult0 As New FvSearchResult
        Dim pSearchResult1 As New FvSearchResult
        Dim pLine As New FvLine

        Dim pScanLineSeg As New FvLineSegment   'W␳̃GbWoC

        Dim pEdgeResult As New FvEdgeResult 'GbW_o
        Dim intCount As Integer                'GbW_̌

        Dim pNowPoint As New FvPoint    'Q̃p^[̃T[`ʂ̊_񂾐̒_
        Dim dblNowAngle As Double       'Q̃p^[̃T[`ʂ̊_񂾒̊px

        '̃Y
        Dim dblDiffX As Double
        Dim dblDiffY As Double
        Dim dblDiffAngle As Double  'P=WA

        ']WvZpꎞϐ
        Dim dblSin As Double
        Dim dblCos As Double
        Dim dblTempX As Double
        Dim dblTempY As Double

        Dim dblTime As Double   '
        Dim intErr As Integer


        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        txtResult.Text = ""

        'ep[^̓Kp
        If ApplyChanges() = -1 Then Exit Sub

        '----------------------------------------------------------------
        'ԌvJn
        AxFvxPerformanceCounter1.StartCount()

        '͈͂ŕ\
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

        If Search(pSearchResult0, pSearchResult1) = 0 Then
            'T[`ʂ͐Ԃŕ\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)

            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult0)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult1)

            'Q̃T[`ʂ̒_ƁAxƂ̌p߂
            pNowPoint.x = (pSearchResult0.x + pSearchResult1.x) / 2
            pNowPoint.y = (pSearchResult0.y + pSearchResult1.y) / 2
            'px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
            '̂߁A̒l͉EŐɂȂ܂B
            dblNowAngle = ArcTan((pSearchResult1.x - pSearchResult0.x), (pSearchResult1.y - pSearchResult0.y))

            'Q̃T[`ʂ̒_Ƀ}[N\
            DrawPointMark(pNowPoint)

            'Ƃ̃YvZ
            dblDiffX = pNowPoint.x - m_pStandardPoint.x
            dblDiffY = pNowPoint.y - m_pStandardPoint.y
            dblDiffAngle = m_dblStandardAngle - dblNowAngle 'Ő̒lɂȂ悤vZ

            txtResult.Text = "Yw " & VisualBasic.Format(dblDiffX, "0.00") & vbCrLf & _
                            "Yx " & VisualBasic.Format(dblDiffY, "0.00") & vbCrLf & _
                            "Ypx " & VisualBasic.Format(dblDiffAngle * 180 / PI, "0.00")


            ' GbWoC̎n_W_𒆐SƂăYpx]
            ' W͈ʂ̍WnƏ㉺tȂ̂ŁA]tɂB
            '
            '  = -dblDiffAngle
            '  | cos -sin || m_pEdgeScanLine.xs - m_pStandardPoint.x | + | m_pStandardPoint.x | + | dblDiffX |
            '  | sin  cos || m_pEdgeScanLine.ys - m_pStandardPoint.y |   | m_pStandardPoint.y |   | dblDiffY |
            dblSin = Math.Sin(-dblDiffAngle)
            dblCos = Math.Cos(-dblDiffAngle)
            dblTempX = (m_pStandardPoint.x * (1 - dblCos)) + (m_pStandardPoint.y * dblSin) + dblDiffX
            dblTempY = -(m_pStandardPoint.x * dblSin) + (m_pStandardPoint.y * (1 - dblCos)) + dblDiffY
            pScanLineSeg.xs = (m_pEdgeScanLine.xs * dblCos) - (m_pEdgeScanLine.ys * dblSin) + dblTempX
            pScanLineSeg.ys = (m_pEdgeScanLine.xs * dblSin) + (m_pEdgeScanLine.ys * dblCos) + dblTempY
            ' I_W]
            pScanLineSeg.xe = (m_pEdgeScanLine.xe * dblCos) - (m_pEdgeScanLine.ye * dblSin) + dblTempX
            pScanLineSeg.ye = (m_pEdgeScanLine.xe * dblSin) + (m_pEdgeScanLine.ye * dblCos) + dblTempY

            'ŌoC\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(192, 192, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pScanLineSeg)

            'GbWos
            AxFvxEdge1.Execute(AxFvxImage1.GetOcx(), pScanLineSeg, intCount)
            AxFvxEdge1.GetErrReport(intErr)

            If intErr = 0 Then
                If intCount >= 1 Then
                    'GbW_ŕ\
                    frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

                    'GbW͂P_݂̂Ȃ̂ŁAindexno0
                    AxFvxEdge1.GetResult(0, pEdgeResult)
                    frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pEdgeResult)

                    txtResult.Text = txtResult.Text & vbCrLf & _
                                    "GbW_W  ( " & VisualBasic.Format(pEdgeResult.x, "0.##") & " , " & VisualBasic.Format(pEdgeResult.y, "0.##") & " )"
                Else
                    MsgBox("GbW܂ł", , "GbWo")
                End If
            Else
                MsgBox(GetEdgeErrMesg(intErr) & " (" & Str(intErr) & ")", vbExclamation, "GbWoG[")
            End If
        End If

        '----------------------------------------------------------------
        'ԌvI
        AxFvxPerformanceCounter1.StopCount(dblTime)
        txtResult.Text = txtResult.Text & vbCrLf & vbCrLf & " : " & VisualBasic.Format(dblTime, "0.00ms")

    End Sub

    'Tvs
    Private Sub btnDoSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDoSample.Click

        Dim intErr As Integer

        '}X^摜ǂݍ
        AxFvxFileAccess1.FilePath = My.Application.Info.DirectoryPath & "\sample1.bmp"
        AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
        AxFvxFileAccess1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample1.bmpǂݍ߂܂ł")
            Exit Sub
        End If

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        MsgBox("}X^摜ǂݍ")


        'p^ǂݍ
        AxFvxPattern1.LoadPattrenFileName = My.Application.Info.DirectoryPath & "\sample1.pat"
        AxFvxPattern1.Load()
        AxFvxPattern1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample1.patǂݍ߂܂ł")
            Exit Sub
        End If

        AxFvxPattern2.LoadPattrenFileName = My.Application.Info.DirectoryPath & "\sample2.pat"
        AxFvxPattern2.Load()
        AxFvxPattern2.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample2.patǂݍ߂܂ł")
            Exit Sub
        End If

        'GbWoݒ
        m_pEdgeScanLine.xs = 300
        m_pEdgeScanLine.ys = 250
        m_pEdgeScanLine.xe = 400
        m_pEdgeScanLine.ye = 250

        'ʒu
        btnSetStandard_Click(sender, e)
        MsgBox("p^Ǎ݁GbWoݒ聕")

        '摜ǂݍ
        AxFvxFileAccess1.FilePath = My.Application.Info.DirectoryPath & "\sample2.bmp"
        AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
        AxFvxFileAccess1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample2.bmpǂݍ߂܂ł")
            Exit Sub
        End If

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        MsgBox("摜ǂݍ")

        's
        btnExecute_Click(sender, e)
        MsgBox("ACgGbWos")

    End Sub

    Public Function GetCorrelationErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetCorrelationErrMesg = "G["
            Case 5001
                GetCorrelationErrMesg = "p^݂Ă܂B"
            Case 5005
                GetCorrelationErrMesg = "p[^Ⴂ܂B"
            Case 5006
                GetCorrelationErrMesg = "^Ⴂ܂B"
            Case 5007
                GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B"
            Case 5008
                GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B"
            Case 5009
                GetCorrelationErrMesg = "p[^NULLlw肳܂B"
            Case 5010
                GetCorrelationErrMesg = "̊mۂɎs܂B"
            Case 5022
                GetCorrelationErrMesg = "p^w肳Ă܂B"
            Case Else
                GetCorrelationErrMesg = "sȃG["
        End Select

    End Function

    Public Function GetPatternErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetPatternErrMesg = "G["
            Case 9502
                GetPatternErrMesg = "T|[gĂȂC[W^CvłB"
            Case 9505
                GetPatternErrMesg = "p[^Ⴂ܂B"
            Case 9506
                GetPatternErrMesg = "̌^Ⴂ܂B"
            Case 9510
                GetPatternErrMesg = "̊mۂɎs܂B"
            Case 9531
                GetPatternErrMesg = "pX̎w肪ԈĂ܂B"
            Case 9533
                GetPatternErrMesg = "p^[݂܂B"
            Case 9540
                GetPatternErrMesg = "p^݂܂B"
            Case Else
                GetPatternErrMesg = "sȃG["
        End Select

    End Function

    Public Function GetEdgeErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetEdgeErrMesg = "G["
            Case 4005
                GetEdgeErrMesg = "p[^Ⴂ܂"
            Case 4006
                GetEdgeErrMesg = "̌^Ⴂ܂"
            Case 4007
                GetEdgeErrMesg = "NULLw肳Ă܂"
            Case 4013
                GetEdgeErrMesg = "̈悪w肳Ă܂"
            Case Else
                GetEdgeErrMesg = "sȃG["
        End Select

    End Function

    Private Sub txtCondition_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtThreshold.KeyPress, txtMiddleThreshold.KeyPress, txtLineWidth.KeyPress, txtCondition.KeyPress, TextBox1.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
